﻿CREATE TABLE [dbo].[DVD] (
    [ID]               INT           IDENTITY (1, 1) NOT NULL,
    [Titel]            VARCHAR (80)  NULL,
    [Originaltitel]    VARCHAR (80)  NULL,
    [Schauspieler]     VARCHAR (MAX) NULL,
    [Produzent]        VARCHAR (80)  NULL,
    [Regie]            VARCHAR (80)  NULL,
    [Land]             VARCHAR (20)  NULL,
    [Dauer]            INT           NULL,
    [Laendercode]      TINYINT       CONSTRAINT [DF_DVD_Laendercode] DEFAULT ((2)) NULL,
    [Ton]              VARCHAR (20)  NULL,
    [Untertitel]       VARCHAR (20)  NULL,
    [Extras]           VARCHAR (MAX) NULL,
    [AnzahlDVDs]       TINYINT       CONSTRAINT [DF_DVD_AnzahlDVDs] DEFAULT ((1)) NULL,
    [Erscheinungsjahr] INT           NULL,
    [Bewertung]        TINYINT       NULL,
    [Kategorie]        NVARCHAR (80) NULL,
    [MediaId]          INT           DEFAULT (NEXT VALUE FOR [dbo].[MediaId]) NULL,
    CONSTRAINT [PK_DVD] PRIMARY KEY CLUSTERED ([ID] ASC)
);


GO
CREATE NONCLUSTERED INDEX [IX_Originaltitel]
    ON [dbo].[DVD]([Originaltitel] ASC);


GO
CREATE NONCLUSTERED INDEX [IX_Titel]
    ON [dbo].[DVD]([Titel] ASC);


GO
-- =============================================
-- Author:		Robert Panther
-- Create date: 29.06.2018
-- Description:	Löschen von DVDs verhindern
-- =============================================
CREATE TRIGGER TRG_DVDLoeschenVerhindern
   ON dbo.DVD
   INSTEAD OF DELETE
AS 
BEGIN
	SET NOCOUNT ON;
	PRINT 'Löschen abgelehnt!'
END