-- Kapitel 8 --

USE MediaBase
GO

-- Daten im XML-Format ausgeben

SELECT *
FROM dbo.Buch
FOR XML AUTO

SELECT *
FROM dbo.Buch
FOR XML AUTO, ROOT('Bcher')

SELECT *
FROM dbo.Buch
FOR XML PATH, ROOT('Bcher')

-- Daten im XML-Format speichern

SELECT TrackNr, Interpret, Titel
FROM dbo.CD_Track cdt
FOR XML AUTO, ROOT('Tracklist')

SELECT *,
    (SELECT TrackNr, Interpret, Titel
    FROM dbo.CD_Track cdt
    WHERE cdt.idCD=cd.ID
    FOR XML AUTO, ROOT('Tracklist')) AS TrackListXML
FROM dbo.CD cd

SELECT *,
    CONVERT(XML, (SELECT TrackNr, Interpret, Titel
    FROM dbo.CD_Track cdt
    WHERE cdt.idCD=cd.ID
    FOR XML AUTO, ROOT('Tracklist'))) AS TrackListXML
FROM dbo.CD cd

SELECT *,
    CONVERT(XML, (SELECT TrackNr, Interpret, Titel
    FROM dbo.CD_Track cdt
    WHERE cdt.idCD=cd.ID
    FOR XML AUTO, ROOT('Tracklist'))) AS TrackListXML
INTO dbo.CDMitTracks_XML
FROM dbo.CD cd

SELECT *
FROM dbo.CDMitTracks_XML

-- Daten aus XML-Spalten auslesen

SELECT ID, Titel, Interpret, TrackListXML
FROM dbo.CDMitTracks_XML

SELECT ID, Titel, Interpret, 
	TrackListXML.value('(/Tracklist/cdt/@Titel)[1]', 'varchar(80)') AS Track1
FROM dbo.CDMitTracks_XML

-- Daten im JSON-Format ausgeben

SELECT Id, Titel, Autor, ISBN10, ISBN13
FROM dbo.Buch
FOR JSON AUTO

SELECT Id, Titel, Autor, ISBN10, ISBN13
FROM dbo.Buch
FOR JSON AUTO, ROOT('Bcher')

SELECT Id, Titel, Autor, ISBN10, ISBN13
FROM dbo.Buch
FOR JSON PATH, ROOT('Bcher')

SELECT Id, Titel, Autor, ISBN10 AS [ISBN.ISBN10], ISBN13 AS [ISBN.ISBN13]
FROM dbo.Buch
FOR JSON PATH, ROOT('Bcher')

-- Daten im JSON-Format speichern

SELECT *,
    (SELECT TrackNr, Interpret, Titel
    FROM dbo.CD_Track cdt
    WHERE cdt.idCD=cd.ID
    FOR JSON AUTO, ROOT('Tracklist')) AS TrackListJSON
FROM dbo.CD cd

SELECT *,
    (SELECT TrackNr, Interpret, Titel
    FROM dbo.CD_Track cdt
    WHERE cdt.idCD=cd.ID
    FOR JSON AUTO, ROOT('Tracklist')) AS TrackListJSON
INTO dbo.CDMitTracks_JSON
FROM dbo.CD cd

-- Daten aus JSON-Spalten auslesen

SELECT ID, Titel, Interpret, TrackListJSON
FROM dbo.CDMitTracks_JSON

SELECT ID, Titel, Interpret, TrackListJSON,
	JSON_QUERY(TrackListJSON, '$.Tracklist') TrackListJSON_Part
FROM dbo.CDMitTracks_JSON

SELECT ID, Titel, Interpret, TrackListJSON,
	ISJSON(TrackListJSON) AS IsValidJson,
	JSON_VALUE(TrackListJSON, '$.Tracklist[0].Titel') AS Track1
FROM dbo.CDMitTracks_JSON

SELECT ID, Titel, Interpret, TrackListJSON,
	JSON_MODIFY(TrackListJSON, '$.Tracklist[0].Titel', 'Bhmische Rhapsodie') AS TrackListJSON_Modified
FROM dbo.CDMitTracks_JSON
WHERE ID=3
