-- Kapitel 9 --

USE MediaBase
GO

CREATE VIEW VW_NeueBuecher AS
SELECT * FROM dbo.Buch WHERE Erscheinungsjahr > 2008

GO

SELECT * FROM VW_NeueBuecher

-- Variablen

DECLARE @CDAnzahl AS int
SET @CDAnzahl = 0

SELECT @CDAnzahl
GO

--

DECLARE @CDAnzahl AS int
SELECT @CDAnzahl = COUNT(*) FROM dbo.CD
SELECT @CDAnzahl AS AnzahlCDs
GO

-- Systemvariablen

SELECT @@VERSION AS Version, @@LANGUAGE AS Sprache, @@SERVERNAME AS SQLServer

SELECT @@CONNECTIONS, @@CPU_BUSY, @@CURSOR_ROWS, @@DATEFIRST, @@DBTS,
@@DEF_SORTORDER_ID, @@DEFAULT_LANGID, @@ERROR, @@FETCH_STATUS, @@IDENTITY,
@@IDLE, @@IO_BUSY, @@LANGID, @@LANGUAGE, @@LOCK_TIMEOUT, @@MAX_CONNECTIONS,
@@MAX_PRECISION, @@MICROSOFTVERSION, @@NESTLEVEL, @@OPTIONS, @@PACK_RECEIVED,
@@PACK_SENT, @@PACKET_ERRORS, @@PROCID, @@REMSERVER, @@ROWCOUNT,
@@SERVERNAME, @@SERVICENAME, @@SPID, @@TEXTSIZE, @@TIMETICKS,
@@TOTAL_ERRORS, @@TOTAL_READ, @@TOTAL_WRITE, @@TRANCOUNT, @@VERSION

-- Tabellenvariablen

DECLARE @CDTitel AS TABLE (ID int, Titel varchar(80))
INSERT INTO @CDTitel SELECT ID, Titel FROM dbo.CD 
SELECT * FROM @CDTitel 

-- temporre Tabellen

SELECT ID, Titel 
INTO #CDTitel
FROM dbo.CD

SELECT ID, Titel 
INTO ##CDTitel
FROM dbo.CD

SELECT ID, Titel 
INTO tempdb.dbo.CDTitel
FROM dbo.CD

SELECT * FROM #CDTitel
SELECT * FROM ##CDTitel
SELECT * FROM tempdb.dbo.CDTitel

-- Fallunterscheidungen und Schleifen

IF (SELECT COUNT(*) FROM dbo.Buch) > 10
	PRINT 'Viele Bcher, nur lesen muss man sie auch! '
ELSE
	PRINT 'Der Trend geht zum Zweitbuch!'

IF (SELECT COUNT(*) FROM dbo.Buch) > 10
	BEGIN
		PRINT 'Viele Bcher, nur lesen muss man sie auch! '
		PRINT '(vielleicht hilft es aber auch, sie unter das Kopfkissen zu legen)'
	END
ELSE
	BEGIN
		PRINT 'Der Trend geht zum Zweitbuch!'
		PRINT '... manch einer hat sogar drei!'
	END

-- WHILE

WHILE (SELECT COUNT(*) FROM dbo.Buch) < 100
	INSERT INTO dbo.Buch (Titel) VALUES (NULL)

SELECT * FROM dbo.Buch

DELETE FROM dbo.Buch WHERE Titel IS NULL

DECLARE @Zaehler int = 0
WHILE @Zaehler < 20
	BEGIN
		SET @Zaehler = @Zaehler+1
		IF @Zaehler = 13
			CONTINUE
		PRINT @Zaehler
	END

DECLARE @Zaehler int = 0
WHILE @Zaehler < 20
	BEGIN
		SET @Zaehler = @Zaehler+1
		IF @Zaehler = 13
			BREAK
		PRINT @Zaehler
	END

-- Debugging

DECLARE @Zaehler AS int

SET @Zaehler = 0

WHILE @Zaehler < 10
BEGIN
	SET @Zaehler = @Zaehler+1
	PRINT @Zaehler
END

-- Fehlerbehandlung

SELECT * FROM dbo.Huch

-- RAISERROR

RAISERROR ('Ungltiger Objektname dbo.Huch', 16, 1)

EXEC sp_addmessage 50001, 16, 'Custom Error', us_english
EXEC sp_addmessage 50001, 16, 'Benutzerdefinierter Fehler', german

RAISERROR (50001, 16, 1)

SELECT * FROM sys.messages

-- TRY..CATCH
SELECT 1/0

--

BEGIN TRY
	SELECT 1/0
END TRY

BEGIN CATCH
	PRINT 'Division durch 0!'
END CATCH

--

BEGIN TRY
	SELECT 1/0
END TRY

BEGIN CATCH
	PRINT 'Division durch 0!'

	SELECT 
        ERROR_NUMBER() AS ErrorNumber,
        ERROR_SEVERITY() AS ErrorSeverity,
        ERROR_STATE() as ErrorState,
        ERROR_PROCEDURE() as ErrorProcedure,
        ERROR_LINE() as ErrorLine,
        ERROR_MESSAGE() as ErrorMessage;

END CATCH

SELECT @@ERROR

-- THROW

THROW 50001, 'neuer benutzerdefinierter Fehler', 1;

BEGIN TRY
	SELECT 1/0
END TRY

BEGIN CATCH
	PRINT 'Division durch 0!';
	THROW
END CATCH

-- Transaktionen

SELECT ID, Titel, Erscheinungsjahr FROM dbo.Buch

BEGIN TRANSACTION

UPDATE dbo.Buch SET Erscheinungsjahr = 2010
SELECT ID, Titel, Erscheinungsjahr FROM dbo.Buch

ROLLBACK TRANSACTION
SELECT ID, Titel, Erscheinungsjahr FROM dbo.Buch

-- geschachtelte Transaktionen

SELECT @@TRANCOUNT
BEGIN TRAN
	SELECT @@TRANCOUNT
	BEGIN TRAN
		SELECT @@TRANCOUNT
	COMMIT TRAN
	SELECT @@TRANCOUNT
COMMIT
SELECT @@TRANCOUNT

-- Deadlocks

-- Fenster 1
BEGIN TRANSACTION
UPDATE dbo.Buch SET Bewertung = 1

-- Fenster 2
BEGIN TRANSACTION
UPDATE dbo.CD SET Bewertung = 2

-- Fenster 1
UPDATE dbo.CD SET Bewertung = 1

-- Fenster 2
UPDATE dbo.Buch SET Bewertung = 2

SELECT @@TRANCOUNT
ROLLBACK
