-- Kapitel 10 (bungen) --

USE MediaBase
GO

-- bung 10.1

CREATE PROCEDURE dbo.USP_MedienAnzeigen
	@Titel varchar(80)
AS
BEGIN
	SELECT 'Buch' AS Medientyp, * FROM dbo.Buch WHERE Titel = @Titel
	SELECT 'CD' AS Medientyp, * FROM dbo.CD WHERE Titel = @Titel
	SELECT 'DVD', * FROM dbo.DVD WHERE Titel = @Titel
END
GO

EXEC dbo.USP_MedienAnzeigen 'Datenbanken entwickeln mit SQL Server 2012'
EXEC dbo.USP_MedienAnzeigen 'Greatest Hits'

-- bung 10.2

CREATE FUNCTION dbo.UFN_LastRelease
(
	@Wer varchar(80)
)
RETURNS int
AS
BEGIN
	DECLARE @MaxJahr AS int

	SELECT @MaxJahr = MAX(Erscheinungsjahr) 
	FROM (SELECT Erscheinungsjahr, Autor AS Wer FROM dbo.Buch
		UNION SELECT Erscheinungsjahr, Interpret AS Wer FROM dbo.CD) AS Gesamt
	WHERE Wer = @Wer
	
	RETURN @MaxJahr
END
GO

PRINT dbo.UFN_LastRelease('Robert Panther')

-- bung 10.3

CREATE FUNCTION dbo.UFN_CDTitelVon
(	
	@Interpret varchar(80)
)
RETURNS TABLE 
AS
RETURN 
(
	SELECT Titel FROM dbo.CD WHERE Interpret=@Interpret
)
GO

SELECT * 
FROM dbo.UFN_CDTitelVon('Queen')

-- bung 10.4

USE [MediaBase]
GO
/****** Object:  Trigger [dbo].[TRG_ChangeLog]    Script Date: 29.06.2018 01:11:41 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
ALTER TRIGGER dbo.TRG_ChangeLog
   ON  dbo.Buch
   AFTER UPDATE, INSERT, DELETE
AS 
BEGIN
	SET NOCOUNT ON;
	
	DECLARE @Aenderungen AS varchar(max)
	DECLARE @ID int

	DECLARE @IDsInserted AS varchar(max) = ''
	DECLARE CUR_Inserted CURSOR FOR SELECT ID FROM INSERTED

	OPEN CUR_Inserted
	FETCH NEXT FROM CUR_Inserted INTO @ID

	WHILE @@FETCH_STATUS = 0
	BEGIN
		SET @IDsInserted = @IDsInserted + ltrim(str(@ID)) + ', '

		FETCH NEXT FROM CUR_Inserted INTO @ID
	END 
	CLOSE CUR_Inserted
	DEALLOCATE CUR_Inserted

	DECLARE @IDsDeleted AS varchar(max) = ''
	DECLARE CUR_Deleted CURSOR FOR SELECT ID FROM DELETED

	OPEN CUR_Deleted
	FETCH NEXT FROM CUR_Deleted INTO @ID

	WHILE @@FETCH_STATUS = 0
	BEGIN
		SET @IDsDeleted = @IDsDeleted + ltrim(str(@ID)) + ', '

		FETCH NEXT FROM CUR_Deleted INTO @ID
	END 
	CLOSE CUR_Deleted
	DEALLOCATE CUR_Deleted
	
	SET @Aenderungen='Hinzugefgte IDs: ' + @IDsInserted
		+ ' Gelschte IDs: ' + @IDsDeleted

	INSERT INTO AenderungsLog (Aenderung)
	VALUES (@Aenderungen)
END

INSERT INTO dbo.Buch (Titel) VALUES ('TriggerTest1'),('TriggerTest2')
DELETE FROM dbo.Buch WHERE Titel LIKE 'TriggerTest%'
SELECT * FROM dbo.AenderungsLog

-- bung 10.5

USE [MediaBase]
GO
/****** Object:  Trigger [dbo].[TRG_ChangeLog]    Script Date: 29.06.2018 01:11:41 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
ALTER TRIGGER dbo.TRG_ChangeLog
   ON  dbo.Buch
   AFTER UPDATE, INSERT, DELETE
AS 
BEGIN
	SET NOCOUNT ON;
	
	DECLARE @Aenderungen AS varchar(max)
	DECLARE @IDsInserted AS varchar(max) = ''
	DECLARE @IDsDeleted AS varchar(max) = ''

	SET @IDsInserted=(SELECT STRING_AGG(CONVERT(VARCHAR(20),ID), ', ') FROM INSERTED)
	SET @IDsDeleted=(SELECT STRING_AGG(CONVERT(VARCHAR(20),ID), ', ') FROM DELETED)

	SET @Aenderungen=CONCAT('Hinzugefgte IDs: ', @IDsInserted, ' Gelschte IDs: ', @IDsDeleted)

	INSERT INTO AenderungsLog (Aenderung)
	VALUES (@Aenderungen)
END

INSERT INTO dbo.Buch (Titel) VALUES ('TriggerTest1'),('TriggerTest2')
DELETE FROM dbo.Buch WHERE Titel LIKE 'TriggerTest%'
SELECT * FROM dbo.AenderungsLog

-- bung 10.6

DECLARE CUR_CD CURSOR
FOR SELECT ID, Titel, Interpret FROM dbo.CD

DECLARE @ID int, @Titel varchar(80), @Interpret varchar(80)

OPEN CUR_CD

FETCH NEXT FROM CUR_CD INTO @ID, @Titel, @Interpret

WHILE @@FETCH_STATUS = 0
BEGIN
	SELECT @Titel AS Titel, @Interpret AS Interpret, (SELECT COUNT(*) FROM dbo.CD_Track WHERE idCD=@ID) AS AnzahlTracks
	
	FETCH NEXT FROM CUR_CD INTO @ID, @Titel, @Interpret
END 
CLOSE CUR_CD
DEALLOCATE CUR_CD

SELECT CD.Titel, CD.Interpret, COUNT(Tracks.ID) AS AnzahlTracks
FROM dbo.CD AS CD LEFT JOIN dbo.CD_Track AS Tracks ON CD.ID=Tracks.idCD
GROUP BY CD.Titel, CD.Interpret
