-- Kapitel 11 --

-- 11.1 Skriptgenerierung oder SQL ist berall

CREATE DATABASE [MediaBase2]
 CONTAINMENT = NONE
 ON  PRIMARY 
( NAME = N'MediaBase2', FILENAME = N'C:\Program Files\Microsoft SQL Server\MSSQL14.SQL2017\MSSQL\DATA\MediaBase2.mdf' , SIZE = 16384KB , FILEGROWTH = 16384KB )
 LOG ON 
( NAME = N'MediaBase2_log', FILENAME = N'C:\Program Files\Microsoft SQL Server\MSSQL14.SQL2017\MSSQL\DATA\MediaBase2_log.ldf' , SIZE = 8192KB , FILEGROWTH = 8192KB )
GO
ALTER DATABASE [MediaBase2] SET COMPATIBILITY_LEVEL = 140
GO
ALTER DATABASE [MediaBase2] SET ANSI_NULL_DEFAULT OFF 
GO
ALTER DATABASE [MediaBase2] SET ANSI_NULLS OFF 
GO
ALTER DATABASE [MediaBase2] SET ANSI_PADDING OFF 
GO
ALTER DATABASE [MediaBase2] SET ANSI_WARNINGS OFF 
GO
ALTER DATABASE [MediaBase2] SET ARITHABORT OFF 
GO
ALTER DATABASE [MediaBase2] SET AUTO_CLOSE OFF 
GO
ALTER DATABASE [MediaBase2] SET AUTO_SHRINK OFF 
GO
ALTER DATABASE [MediaBase2] SET AUTO_CREATE_STATISTICS ON(INCREMENTAL = OFF)
GO
ALTER DATABASE [MediaBase2] SET AUTO_UPDATE_STATISTICS ON 
GO
ALTER DATABASE [MediaBase2] SET CURSOR_CLOSE_ON_COMMIT OFF 
GO
ALTER DATABASE [MediaBase2] SET CURSOR_DEFAULT  GLOBAL 
GO
ALTER DATABASE [MediaBase2] SET CONCAT_NULL_YIELDS_NULL OFF 
GO
ALTER DATABASE [MediaBase2] SET NUMERIC_ROUNDABORT OFF 
GO
ALTER DATABASE [MediaBase2] SET QUOTED_IDENTIFIER OFF 
GO
ALTER DATABASE [MediaBase2] SET RECURSIVE_TRIGGERS OFF 
GO
ALTER DATABASE [MediaBase2] SET  DISABLE_BROKER 
GO
ALTER DATABASE [MediaBase2] SET AUTO_UPDATE_STATISTICS_ASYNC OFF 
GO
ALTER DATABASE [MediaBase2] SET DATE_CORRELATION_OPTIMIZATION OFF 
GO
ALTER DATABASE [MediaBase2] SET PARAMETERIZATION SIMPLE 
GO
ALTER DATABASE [MediaBase2] SET READ_COMMITTED_SNAPSHOT OFF 
GO
ALTER DATABASE [MediaBase2] SET  READ_WRITE 
GO
ALTER DATABASE [MediaBase2] SET RECOVERY SIMPLE 
GO
ALTER DATABASE [MediaBase2] SET  MULTI_USER 
GO
ALTER DATABASE [MediaBase2] SET PAGE_VERIFY CHECKSUM  
GO
ALTER DATABASE [MediaBase2] SET TARGET_RECOVERY_TIME = 60 SECONDS 
GO
ALTER DATABASE [MediaBase2] SET DELAYED_DURABILITY = DISABLED 
GO
USE [MediaBase2]
GO
ALTER DATABASE SCOPED CONFIGURATION SET LEGACY_CARDINALITY_ESTIMATION = Off;
GO
ALTER DATABASE SCOPED CONFIGURATION FOR SECONDARY SET LEGACY_CARDINALITY_ESTIMATION = Primary;
GO
ALTER DATABASE SCOPED CONFIGURATION SET MAXDOP = 0;
GO
ALTER DATABASE SCOPED CONFIGURATION FOR SECONDARY SET MAXDOP = PRIMARY;
GO
ALTER DATABASE SCOPED CONFIGURATION SET PARAMETER_SNIFFING = On;
GO
ALTER DATABASE SCOPED CONFIGURATION FOR SECONDARY SET PARAMETER_SNIFFING = Primary;
GO
ALTER DATABASE SCOPED CONFIGURATION SET QUERY_OPTIMIZER_HOTFIXES = Off;
GO
ALTER DATABASE SCOPED CONFIGURATION FOR SECONDARY SET QUERY_OPTIMIZER_HOTFIXES = Primary;
GO
USE [MediaBase2]
GO
IF NOT EXISTS (SELECT name FROM sys.filegroups WHERE is_default=1 AND name = N'PRIMARY') ALTER DATABASE [MediaBase2] MODIFY FILEGROUP [PRIMARY] DEFAULT
GO

--

USE [MediaBase]
GO

/****** Object:  Table [dbo].[Buch]    Script Date: 29.06.2018 23:55:48 ******/
SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE TABLE [dbo].[Buch](
	[ID] [int] IDENTITY(1,1) NOT NULL,
	[ISBN10] [char](10) NULL,
	[ISBN13] [char](14) NULL,
	[Autor] [varchar](80) NULL,
	[Titel] [varchar](80) NULL,
	[Verlag] [varchar](80) NULL,
	[Seiten] [int] NULL,
	[Auflage] [tinyint] NULL,
	[Sprache] [varchar](20) NULL,
	[Hardcover] [bit] NULL,
	[Erscheinungsjahr] [int] NULL,
	[Bewertung] [tinyint] NULL,
	[Beschreibung] [varchar](max) NULL,
	[Kategorie] [varchar](80) NULL,
	[MediaId] [int] NULL,
 CONSTRAINT [PK_Buch] PRIMARY KEY CLUSTERED 
(
	[ID] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

ALTER TABLE [dbo].[Buch] ADD  CONSTRAINT [DF_Buch_Sprache]  DEFAULT ('Deutsch') FOR [Sprache]
GO

ALTER TABLE [dbo].[Buch] ADD  DEFAULT (NEXT VALUE FOR [dbo].[MediaId]) FOR [MediaId]
GO

-- 11.2 Verwalten von Datenbanken

CREATE DATABASE CrashTestDummy ON  PRIMARY 
( NAME = N'CrashTestDummy', FILENAME = N'c:\Temp\CrashTestDummy.mdf' , SIZE = 20480KB , FILEGROWTH = 10%)
 LOG ON 
( NAME = N'CrashTestDummy_log', FILENAME = N'c:\Temp\CrashTestDummy_log.ldf' , SIZE = 10240KB , FILEGROWTH = 10%)
GO

ALTER DATABASE CrashTestDummy SET COMPATIBILITY_LEVEL = 100
GO
ALTER DATABASE CrashTestDummy SET COMPATIBILITY_LEVEL = 140
GO

ALTER DATABASE CrashTestDummy SET READ_ONLY
GO
ALTER DATABASE CrashTestDummy SET READ_WRITE 
GO

ALTER DATABASE CrashTestDummy SET SINGLE_USER
GO
ALTER DATABASE CrashTestDummy SET MULTI_USER 
GO

ALTER DATABASE CrashTestDummy COLLATE French_CI_AI
GO

ALTER DATABASE CrashTestDummy MODIFY NAME = CrashDummy
GO

DROP DATABASE CrashTestDummy
GO

DROP DATABASE IF EXISTS CrashDummy
GO

-- 11.3. Verwalten von Datenbankobjekten

USE MediaBase

-- Tabellen

CREATE TABLE dbo.Adresse
(ID int IDENTITY(1,1) NOT NULL,
Name varchar(80) NOT NULL,
Strasse varchar(80) NULL,
PLZ char(5) NULL,
Wohnort varchar(80) NULL,
CONSTRAINT PK_Adresse PRIMARY KEY (ID))
GO

ALTER TABLE dbo.Adresse ADD Geburtstag datetime
GO

--

ALTER TABLE dbo.CD_Track 
DROP CONSTRAINT FK_CD_Track_CD
GO

ALTER TABLE dbo.CD_Track
WITH CHECK ADD  CONSTRAINT FK_CD_Track_CD
FOREIGN KEY(idCD)
REFERENCES dbo.CD(ID)
GO

DROP TABLE dbo.Adresse
GO

DROP TABLE IF EXISTS dbo.Adresse
GO

-- Indizes

CREATE INDEX IX_VerlagErscheinungsjahrAutorTitel
ON dbo.Buch (Verlag, Erscheinungsjahr, Autor, Titel)

ALTER INDEX ALL ON dbo.Buch REORGANIZE
ALTER INDEX ALL ON dbo.Buch REBUILD

DROP INDEX IX_VerlagErscheinungsjahrAutorTitel ON dbo.Buch

-- Sichten, Funktionen, gespeicherte Prozeduren und Trigger

CREATE VIEW dbo.VW_Dummy AS SELECT * FROM dbo.Buch WHERE Erscheinungsjahr > 1980
GO

ALTER VIEW dbo.VW_Dummy AS SELECT * FROM dbo.Buch WHERE Erscheinungsjahr > 1990
GO

DROP VIEW dbo.VW_Dummy
GO

CREATE OR ALTER VIEW dbo.VW_Dummy AS SELECT * FROM dbo.Buch WHERE Erscheinungsjahr > 2000
GO

-- DDL-Trigger

USE [MediaBase]
GO

SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE TABLE [dbo].[DDLAenderungsLog](
	[ID] [int] IDENTITY(1,1) NOT NULL,
	[Benutzer] [varchar](128) NULL,
	[Zeitpunkt] [datetime] NULL,
	[Aenderung] [xml] NULL,
 CONSTRAINT [PK_DDLAenderungsLog] PRIMARY KEY CLUSTERED 
(
	[ID] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]

GO

ALTER TABLE [dbo].[DDLAenderungsLog] ADD  CONSTRAINT [DF_DDLAenderungsLog_Benutzer]  DEFAULT (suser_sname()) FOR [Benutzer]
GO

ALTER TABLE [dbo].[DDLAenderungsLog] ADD  CONSTRAINT [DF_DDLAenderungsLog_Zeitpunkt]  DEFAULT (getdate()) FOR [Zeitpunkt]
GO

--

CREATE TRIGGER TRG_Datenbank ON DATABASE
FOR DDL_DATABASE_LEVEL_EVENTS
AS
BEGIN
	PRINT 'Datenbank-nderung!'
	INSERT INTO MediaBase.dbo.DDLAenderungsLog (Aenderung) VALUES (EVENTDATA())
END
GO

CREATE VIEW dbo.VW_EinBuch 
AS SELECT TOP 1 * FROM dbo.Buch
GO

DROP VIEW dbo.VW_EinBuch 
GO

SELECT * FROM dbo.DDLAenderungsLog

DROP TRIGGER TRG_Datenbank ON DATABASE
