-- Kapitel 13 --

-- 13.1 Sichern von Datenbankdateien

-- Offline und Online schalten

USE master

ALTER DATABASE MediaBase SET OFFLINE
ALTER DATABASE MediaBase SET ONLINE

-- Trennen und Anhngen

USE [master]
GO
ALTER DATABASE [MediaBase] SET SINGLE_USER WITH ROLLBACK IMMEDIATE
GO
EXEC master.dbo.sp_detach_db @dbname = N'MediaBase'
GO

USE [master]
GO
CREATE DATABASE [MediaBase] ON 
( FILENAME = N'C:\SQLServer\Data\MediaBase.mdf' ),
( FILENAME = N'C:\SQLServer\Data\MediaBase_log.ldf' )
 FOR ATTACH
GO

-- 13.3 Sichern von Datenbankdateien

BACKUP DATABASE [MediaBase] TO  DISK = N'C:\SQLServer\Backup\MediaBase.bak' WITH FORMAT, INIT,  MEDIANAME = N'MediaBase Full Backup',  NAME = N'MediaBase-Vollstndig Datenbank Sichern', SKIP, NOREWIND, NOUNLOAD,  STATS = 10
GO
declare @backupSetId as int
select @backupSetId = position from msdb..backupset where database_name=N'MediaBase' and backup_set_id=(select max(backup_set_id) from msdb..backupset where database_name=N'MediaBase' )
if @backupSetId is null begin raiserror(N'Fehler beim berprfen. Sicherungsinformationen fr die Datenbank "MediaBase" wurden nicht gefunden.', 16, 1) end
RESTORE VERIFYONLY FROM  DISK = N'C:\SQLServer\Backup\MediaBase.bak' WITH  FILE = @backupSetId,  NOUNLOAD,  NOREWIND
GO

USE MediaBase
DROP TABLE dbo.CDMitTracks
GO

USE [master]
ALTER DATABASE [MediaBase] SET SINGLE_USER WITH ROLLBACK IMMEDIATE
BACKUP LOG [MediaBase] TO  DISK = N'C:\SQLServer\Backup\MediaBase_LogBackup_2018-07-02_00-17-58.bak' WITH NOFORMAT, NOINIT,  NAME = N'MediaBase_LogBackup_2018-07-02_00-17-58', NOSKIP, NOREWIND, NOUNLOAD,  NORECOVERY ,  STATS = 5
RESTORE DATABASE [MediaBase] FROM  DISK = N'C:\SQLServer\Backup\MediaBase.bak' WITH  FILE = 1,  NOUNLOAD,  REPLACE,  STATS = 5
ALTER DATABASE [MediaBase] SET MULTI_USER
GO

-- BULK INSERT

USE MediaBase
SELECT * FROM dbo.CD

BULK INSERT dbo.CD FROM N'c:\SQLServer\CD_Import.txt' 
WITH (FIELDTERMINATOR=';', ROWTERMINATOR='\r\n')

SELECT * FROM dbo.CD
